         title   SplitNC2

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  \MASM32V1\include\Windows.inc
            include  \MASM32V1\include\user32.inc
            include  \MASM32V1\include\kernel32.inc
            include  \MASM32V1\include\gdi32.inc
            include  \MASM32V1\include\comctl32.inc
            include  \MASM32V1\include\comdlg32.inc

;       include  \MASM32V1\include\DSPMACRO.asm

         includelib  \MASM32V1\lib\user32.lib
         includelib  \MASM32V1\lib\kernel32.lib
         includelib  \MASM32V1\lib\gdi32.lib
         includelib  \MASM32V1\lib\comctl32.lib
         includelib  \MASM32V1\lib\comdlg32.lib

;===================================================
; PROTO, MACRO, and Data section
;===================================================
WinMain         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SplitBarProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD

.const
IDM_EXIT       equ 2001

.data
ClassName      db  'SplitNC2',0
AppName        db  'SplitNC2 - Uses No Splitter Control',0
RichEdit       db  'RichEdit20A',0
RichEdDLL      db  'RICHED20.DLL',0
StatClass      db  'msctls_statusbar32',0
MenuName       db  'MainMenu',0
szNull         db  0

SplitH         dd  0, 79, 0, 81
SplitV         dd  129, 0, 131, 0

.data?
hInst          dd  ?
CommandLine    dd  ?
MainExit       dd  ?
hWnd           dd  ?
hREdDll        dd  ?
MenuCnt        dd  ?

hWndStat       dd  ?
hWndChild1     dd  ?
hWndChild2     dd  ?
hWndChild3     dd  ?
hSplitBar      dd  ?
BarType        dd  ?
hBR            dd  ?
sbParts        dd  4   dup(?)

;---------- [Structures] ----------

.code

;===================================================
; Program initialization section
;===================================================
start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax
      INVOKE     GetCommandLine
         mov     CommandLine, eax

        call     InitCommonControls
      INVOKE     LoadLibrary, addr RichEdDLL ; Load the Riched20.dll
         mov     hREdDll, eax
      .if !eax
;         INVOKE     MessageBox, NULL, addr szError1, addr szAppName, MB_OK or MB_ICONERROR
            jmp     NoGo
      .endif

      INVOKE     WinMain, hInst ,NULL, CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax
      INVOKE     FreeLibrary, hREdDll

NoGo:
      INVOKE     ExitProcess, MainExit

;===================================================
; WinMain procedure
;===================================================
WinMain proc  uses ebx  hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
        push     hInst
         pop     wc.hInstance
         mov     wc.hbrBackground, COLOR_BTNFACE+1
         mov     wc.lpszMenuName, offset MenuName
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, NULL, IDI_APPLICATION
         mov     wc.hIcon, eax
         mov     wc.hIconSm, eax
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 353
         shr     eax, 1
        push     eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 311
         shr     eax, 1
         pop     ebx

;---------- [Create the Main Window] ----------
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassName,\
                 addr AppName, WS_OVERLAPPEDWINDOW,\
                 ebx, eax, 353, 311, NULL, NULL, hInst, NULL
         mov     hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd

;---------- [Message loop] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
            .break .if (!eax)
            INVOKE     TranslateMessage, addr msg
            INVOKE     DispatchMessage, addr msg
      .endw
         mov     eax, msg.wParam
         ret
WinMain endp

;===================================================
; WinProc procedure
;===================================================
WndProc proc  uses esi edi ebx  hwnd:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    xPos:DWORD, yPos

;---------- [Create the Control(s) and one time stuff] ----------
      .if wMsg == WM_CREATE

;---------- [Create the status bar window] ----------
         INVOKE     CreateWindowEx, 0, addr StatClass, 0,\
                    WS_CHILD or WS_BORDER or WS_VISIBLE or SBS_SIZEGRIP,\
                    0, 0, 0, 0, hwnd, 0, hInst, 0  
            mov     hWndStat, eax

;---------- [Control window] ----------
         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr RichEdit, NULL,\
                    WS_CHILD or WS_VISIBLE or ES_MULTILINE or\
                    ES_NOHIDESEL or ES_SAVESEL or ES_SELECTIONBAR or\
                    WS_HSCROLL or ES_AUTOHSCROLL or\
                    WS_VSCROLL or ES_AUTOVSCROLL or WS_CLIPSIBLINGS,\
                    0, 0, 0, 0, hwnd, 44, hInst, NULL
            mov     hWndChild1, eax

         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr RichEdit, NULL,\
                    WS_CHILD or WS_VISIBLE or ES_MULTILINE or\
                    ES_NOHIDESEL or ES_SAVESEL or ES_SELECTIONBAR or\
                    WS_HSCROLL or ES_AUTOHSCROLL or\
                    WS_VSCROLL or ES_AUTOVSCROLL or WS_CLIPSIBLINGS,\
                    0, 0, 0, 0, hwnd, 45, hInst, NULL
            mov     hWndChild2, eax

         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr RichEdit, NULL,\
                    WS_CHILD or WS_VISIBLE or ES_MULTILINE or\
                    ES_NOHIDESEL or ES_SAVESEL or ES_SELECTIONBAR or\
                    WS_HSCROLL or ES_AUTOHSCROLL or\
                    WS_VSCROLL or ES_AUTOVSCROLL or WS_CLIPSIBLINGS,\
                    0, 0, 0, 0, hwnd, 46, hInst, NULL
            mov     hWndChild3, eax

         INVOKE     SendMessage, hWndChild1, EM_SETBKGNDCOLOR, 0, 00ffffe0h
         INVOKE     SendMessage, hWndChild2, EM_SETBKGNDCOLOR, 0, 00ffffe0h
         INVOKE     SendMessage, hWndChild3, EM_SETBKGNDCOLOR, 0, 00ffffe0h

;---------- [Move and Size the Control(s)] ----------
      .elseif wMsg == WM_SIZE

;---------- [Size the Statusbar Control] ----------
            mov     eax, lParam       ; Get width
            and     eax, 0ffffh       ; Lowword
            shr     eax, 2            ; /4
            mov     ecx, eax          ; Save factor
            mov     sbParts, eax      ; Make part 1 1/4 the width
            add     eax, ecx
            mov     [sbParts+4], eax  ; and also part2, .. etc
            add     eax, ecx
            mov     [sbParts+8], eax
            mov     [sbParts+12], -1  ; The last part extends to the end
         INVOKE     SendMessage, hWndStat, SB_SETPARTS, 4, addr sbParts
         INVOKE     MoveWindow, hWndStat, 0, 0, 0, 0, TRUE

         INVOKE     GetWindowRect, hWndStat, addr rect ; Rectangle of statusbar
            mov     eax, rect.bottom
            sub     eax, rect.top                      ; eax = height of statusbar
           push     eax
         INVOKE     GetClientRect, hWnd, addr rect
            pop     eax
            dec     eax
            sub     rect.bottom, eax

            mov     ecx, 1 ;TBHgt
            add     rect.top, ecx
            mov     edx, rect.top
            mov     SplitV[4], edx
            mov     edx, rect.bottom
            sub     edx, ecx
            sub     edx, 4
            mov     SplitV[12], edx

            mov     ecx, SplitV
            mov     SplitH[8], ecx
         INVOKE     MoveWindow, hWndChild1, 1, rect.top, SplitV, SplitH[4], FALSE
            mov     ecx, rect.right
            sub     ecx, SplitV[8]
            mov     edx, rect.bottom
            sub     edx, rect.top
         INVOKE     MoveWindow, hWndChild2, SplitV[8], rect.top, ecx, edx, FALSE
            mov     edx, rect.bottom
            mov     edi, SplitH[12]
            sub     edx, SplitH[12]
         INVOKE     MoveWindow, hWndChild3, 1, edi, SplitV, edx, TRUE

      .elseif wMsg == WM_NOTIFY

;---------- [System and user commands] ----------
      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde                          ; Only low word contains command
         .if eax == IDM_EXIT
            INVOKE     SendMessage, hwnd, WM_CLOSE, 0 ,0

         .endif

      .elseif wMsg == WM_MOUSEMOVE

;---------- [Capture the mouse if within an area] ----------
         INVOKE     GetClientRect, hWnd, addr rect
            mov     eax, lParam
            mov     edx, eax
            and     eax, 0ffffh   
            mov     xPos, eax
            shr     edx, 16
            mov     yPos, edx

         .if eax > SplitH && eax < SplitH[8] && edx >= SplitH[4] && edx <= SplitH[12] && BarType != 2
            INVOKE     LoadCursor, hInst, 899
            INVOKE     SetCursor, eax
            INVOKE     SetCapture, hwnd
               mov     BarType, 1
         .elseif eax >= SplitV && eax <= SplitV[8] && edx > SplitV[4] && edx < SplitV[12] && BarType != 1
            INVOKE     LoadCursor, hInst, 898
            INVOKE     SetCursor, eax
            INVOKE     SetCapture, hwnd
               mov     BarType, 2
         .else

;---------- [Release the mouse if out of the area] ----------
            .if wParam != MK_LBUTTON
                  xor     esi, esi
               .if BarType == 1
                     lea     esi, SplitH
               .elseif BarType == 2
                     lea     esi, SplitV
               .endif
               .if esi
                  .if eax < [esi] || eax > [esi+8] || edx < [esi+4] || edx > [esi+12]
                        and     BarType, 0
                     INVOKE     ReleaseCapture
                  .endif
               .endif
            .endif
         .endif

         .if wParam == MK_LBUTTON
            INVOKE     GetClientRect, hWnd, addr rect
               mov     ecx, xPos
               mov     edx, yPos
               sub     rect.bottom, 21
            .if ecx > rect.left && ecx < rect.right && edx > rect.top && edx < rect.bottom
            .else
               INVOKE     LoadCursor, 0, IDC_ARROW
               INVOKE     SetCursor, eax
                  jmp     Ret0
            .endif

;---------- [Create and drag the Splitter bar] ----------
            .if BarType == 1                   ; Horizontal
                  mov     ecx, SplitV
               .if xPos < ecx
                  INVOKE     LoadCursor, hInst, 899
                  INVOKE     SetCursor, eax
                  .if !hSplitBar
                     INVOKE     CreateDialogParam, hInst, 4801, hWnd, offset SplitBarProc, 1
                  .endif
                     mov     eax, yPos
                     dec     eax
                     mov     SplitH[4], eax
                     add     eax, 2
                     mov     SplitH[12], eax
                  INVOKE     GetWindowRect, hWnd, addr rect
                     add     rect.left, 9 ;6
                     mov     eax, rect.top
                     add     eax, 44
                     add     eax, SplitH[4]
                     inc     eax
                     mov     rect.top, eax
                     mov     edx, SplitH[8]
                     sub     edx, 4
                  INVOKE     MoveWindow, hSplitBar, rect.left, rect.top, edx, 2, TRUE
               .endif
            .endif

            .if BarType == 2                       ; Vertical
               INVOKE     LoadCursor, hInst, 898
               INVOKE     SetCursor, eax
               .if !hSplitBar
                  INVOKE     CreateDialogParam, hInst, 4801, hWnd, offset SplitBarProc, 2
               .endif
                  mov     eax, xPos
                  dec     eax
                  mov     SplitV, eax
                  add     eax, 2
                  mov     SplitV[8], eax
               INVOKE     GetWindowRect, hWnd, addr rect
                  add     rect.top, 47 ;44
                  mov     eax, rect.top
                  add     eax, 25 ;21
                  sub     rect.bottom, eax
                  add     rect.left, 6
                  mov     ecx, rect.left
                  add     ecx, SplitV
                  inc     ecx
               INVOKE     MoveWindow, hSplitBar, ecx, rect.top, 2, SplitV[12], TRUE
            .endif
         .endif

      .elseif wMsg == WM_LBUTTONUP

;---------- [Restore the cursor and call WM_SIZE] ----------
         INVOKE     LoadCursor, 0, IDC_ARROW
         INVOKE     SetCursor, eax
            and     BarType, 0
         .if hSplitBar
            INVOKE     ReleaseCapture
            INVOKE     SplitBarProc, hSplitBar, WM_COMMAND, IDCANCEL, 0
               and     hSplitBar, 0
            INVOKE     GetClientRect, hWnd, addr rect
               mov     edx, rect.bottom
               shl     edx, 16
               mov     ecx, rect.right
               mov     dx, cx
            INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx
         .endif

      .elseif wMsg == WM_CLOSE
         INVOKE     DestroyWindow, hwnd

      .elseif wMsg == WM_DESTROY
         INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
            ret
      .endif

Ret0:
         xor    eax, eax
         ret
WndProc endp

;=========================================================================
; Splitter Bar PROCEDURE
;=========================================================================
SplitBarProc PROC    hdlg:DWORD, wmsg, wparam, lparam
LOCAL    hBrush:DWORD

         cmp     wmsg, WM_INITDIALOG   ; If message is INITDIALOG then
         jne     NotInit               ; check wmsg
         mov     eax, hdlg
         mov     hSplitBar, eax
         jmp     DlgDone

NotInit:
         cmp     wmsg, WM_CTLCOLORDLG
         je      ColorDlg
         cmp     wmsg, WM_COMMAND      ; Is message a WM_COMMAND?
         mov     eax, wparam           ; Otherwise, see if it's OK or CANCEL
         cmp     eax, IDCANCEL         ; that was pressed
         je      CancleIt              ; and if not either of these
         jmp     DlgDone

ColorDlg:
      INVOKE     CreateSolidBrush, 0000ff00h
         mov     hBrush, eax
         ret

CancleIt:
      INVOKE     DeleteObject, hBrush
      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE             ; Return
         jmp     DlgRet                ; with TRUE

DlgDone:
         mov     eax, FALSE            ; Return with FALSE

DlgRet:
         ret                           ; Return
SplitBarProc ENDP

end start